Imports System.io
Imports System.Math

Module MpPIGL10
    Sub Main()
        Console.WriteLine("-----------------------------------------------------")
        Console.WriteLine("                  Pi Calculation")
        Console.WriteLine("(Gauss-Legendre driven by fft4g_h with a radix " & RX)
        Console.WriteLine("-----------------------------------------------------")

        Console.Write("How many digits do you want? > ")
        Dim dc As Integer = Integer.Parse(Console.ReadLine())

        Console.WriteLine("Output file name? (If no input, the result will be displayed in this screen.)")
        Console.Write("> ")
        Dim filename As String = Console.ReadLine()

        Dim pi() As Short

        Dim StartTime As Date = Date.Now
        Console.Write(" --- Calculation Started at ")
        Console.WriteLine(StartTime)

        MpPIGL(dc \ RXdc + 10, pi)

        Dim EndTime As Date = Date.Now
        Console.Write(" --- Completed at ")
        Console.WriteLine(EndTime)
        Console.Write("Elapsed time : ")
        Console.Write(CInt(Date.Now.Subtract(StartTime).TotalMilliseconds))
        Console.WriteLine("ms")

        If filename.Length = 0 Then
            Console.WriteLine("No file name has been specified.")
            Console.WriteLine("The result will be displayed below. OK? (Hit Enter key.)")
            Console.ReadLine()

            Console.Write(pi(0) & ".")
            For i As Integer = 1 To dc \ RXdc
                Console.Write(pi(i).ToString.PadLeft(RXdc, "0"c))
            Next
            Console.WriteLine()
        Else
            Dim sw As New StreamWriter(New FileStream(filename, FileMode.Create))
            sw.Write(pi(0) & ".")
            For i As Integer = 1 To dc \ RXdc
                sw.Write(pi(i).ToString.PadLeft(RXdc, "0"c))
            Next
            sw.Close()

            Console.Write("The results has been stored in the file : ")
            Console.WriteLine(filename)
        End If

        Console.WriteLine("------- Hit Enter key to quit. -------")
        Console.ReadLine()
    End Sub

    Public Sub MpPIGL(ByVal np As Integer, ByRef pi() As Short)
        Const MACC As Integer = 5
        Dim n As Integer = np + MACC

        'a = 1
        Dim a(n) As Short
        a(0) = 1

        'b = 1/SQRT(2)
        Dim two() As Short = {2}
        Dim b(n) As Short
        Dim dum(n) As Short
        MpSQRT(two, 0, 1, dum, b)
        Erase dum

        't = 1/4
        Dim t(n) As Short
        If RXdc = 1 Then
            t(1) = 2
            t(2) = 5
        Else
            t(1) = RX \ 4
        End If

        'p = 1
        Dim p(n) As Short
        p(n - 1) = 1
        Dim rpp As Integer = 0

        Dim x(n) As Short
        Dim s(2 * n - 1) As Short
        Dim binv() As Short

        Dim ir As Integer
        Do
            'x = (a + b) / 2
            MpADD(a, 0, b, 0, n, x)
            MpSDV(x, 1, n, 2, x, ir)

            'y = SQRT(a * b)
            MpMUL(a, 0, n, b, 0, n, s)
            If binv Is Nothing Then
                ReDim binv(n)
                MpSQRT(s, 1, n, b, binv)
            Else
                MpSQRT(s, 1, n, b, binv, binv)
            End If

            't = t - p * (a - x) * (a - x)
            Dim isign As Integer
            MpSUB(a, 0, x, 0, n, s, isign)
            MpMUL(s, 0, n, s, 0, n, s)
            MpMUL(s, 1, n, p, rpp, n, s)
            MpSUB(t, 0, s, n, n, t, isign)

            'a = x
            'p = 2p
            Array.Copy(x, 0, a, 0, n)
            MpSMU(p, rpp, n, 2, p)
            rpp = 1

            'Convergence Test
            Dim i As Integer
            For i = 0 To n - 2
                If a(i) <> b(i) Then Exit For
            Next

            Console.Write("Converging to about ")
            Console.Write(CInt(i * RXdc))
            Console.WriteLine(" digits")

            If i = n - 1 Then Exit Do
        Loop

        MpADD(a, 0, b, 0, n, x)
        MpMUL(x, 1, n, x, 1, n, s)
        MpSDV(s, 1, n, 4, s, ir)
        MpINV(t, 1, n, t)
        MpMUL(s, 0, n, t, 1, n, s)

        ReDim pi(np - 1)
        Array.Copy(s, 1, pi, 0, np)
    End Sub
End Module
